#include <pw/core/vector.hpp>
#include <pw/core/serialize.hpp>
#include <pw/scene/node.hpp>
#include <pw/scene/transform.hpp>
#include <pw/scene/scene.hpp>
#include <pw/scene/entity.hpp>


#include <pw/core/serialize.hpp>

#include <iostream>

using pw::scene;
using pw::entity;


struct test {
    int val = 0;
    test(int v) : val(v) {}
};


void test_stack()
{
    auto s = scene();
    auto e = entity(s);

    auto t = e.add_component<test>(112);

    std::cout << t.val << std::endl;

}

void test_heap()
{
    auto s = std::make_unique<scene>();

    auto e = std::make_unique<entity>(*s);

    auto t = e->add_component<test>(112);

    std::cout << t.val << std::endl;

}


int main()
{
    test_stack();
    test_heap();

}
